Subject: Re: bug#77916: Unicode Variation Selector 15 ignored by emacs GTK and honoured by emacs -nw

From: Дилян Палаузов<[email-masked]>
Date: Sat, 19 Apr 2025 19:06:21 +0300

Hello Eli,

the black hole turned out to be caused by tmux, as without tmux the black hole does not appear.  I filled https://github.com/tmux/tmux/issues/4475 .

Greetings
  Дилян

-----Original Message-----
From: Eli Zaretskii <[email-masked]>
To: Дилян Палаузов <[email-masked]>
Cc: [email-masked]
Subject: Re: bug#77916: Unicode Variation Selector 15 ignored by emacs GTK and honoured by emacs -nw
Date: 19/04/25 16:18:58

> From: Дилян Палаузов
> 	 <[email-masked]>
> Cc: [email-masked]
> Date: Sat, 19 Apr 2025 15:51:59 +0300
> 
> When emacs thinks in eww mode that a link is suspicious, it uses by default red background for blue text.  I think this is low contrast and therefore bad.  What I see is https://mail.aegee.org/dpa/island/emacs-gtk-warning-hyperlinks.png . The red is ff0000, the blue is 5452b2, or 3a5fcd (depending on where I click to select the colour), the contrast ratio is 1:62 or 1:1.42.
> 
> To be readable by everybody the contrast should be at least 1:3.

I'm not sure we want to have such links be readable.  We want them to
have appearance that stands out, and the current colors do that job
very well, IMO.

> The terminal emulatior I am using is GNOME Terminal Version 3.54.4 GNOME 47 Using VTE version 0.78.4 +BIDI +GNUTLS +ICU +SYSTEMD.

I suggest to take this up with the developers of this emulator.  There
could be some option that you need to tweak or maybe a font setup you
need to adjust.  Emacs just sends the characters to the terminal,
leaving the rest to the terminal emulator.

> C-x C-u =  is below.  In all the output the clock is in colour.

This output suggests that Emacs did its job:

>               display: composed to form "🕛︎" (see below)
> 
> Composed with the following character(s) "︎" using this font:
>   ftcrhb:-GOOG-Noto Color Emoji-regular-normal-normal-*-14-*-*-*-m-0-iso10646-1
> by these glyphs:
>   [0 1 128347 826 17 0 18 13 4 nil]
>   [0 1 65038 3 17 0 0 0 0 [0 0 0]]
> with these character(s):
>   ︎ (#xfe0e) VARIATION SELECTOR-15

This tells us that Emacs did combine VS-15 with the emoji, so I
suspect the problem is with the font.

Does anyone else who uses Noto Color Emoji see this problem?  If so,
can you please take this up with the font developers?

Or maybe this is a problem with Cairo?